
//
// othelloMCspeler.cc provides MCspeler
// Roy van Hal en Walter Kosters
// 4 maart 2020
//

const int MCSPELLEN = 100; // playouts

class MCspeler : public Basisspeler {
public:
  MCspeler (othello* spelPointer);
  int volgendeZet ( );
  int speelRandomSpel (othello & randomspel);
};//MCspeler

// constructor
MCspeler::MCspeler (othello* spelPointer) {
  spel = spelPointer;
}//MCspeler::MCspeler

// speel een random spel uit
int MCspeler::speelRandomSpel (othello & randomspel) {
  int countW, countZ;
  while ( ! randomspel.finished ( ) ) {
    if ( randomspel.numberofmoves ( ) == 0 ) { // pass!
      randomspel.playertomove = ! randomspel.playertomove;
    }//if
    randomspel.dothemove (rand ( ) % randomspel.numberofmoves ( ) + 1);
  }//while
  return (randomspel.gamestatus (countW,countZ));
}//MCSpeler::speelRandomSpel

// de beste Monte Carlo zet (er is er minstens een)
int MCspeler::volgendeZet ( ) {
  othello kopie;
  int huidigeScore;
  int besteScore = -1;
  int aantal = spel->numberofmoves ( );
  int besteZet = 1;
  for ( int i = 1; i <= aantal; i++ ) {
    huidigeScore = 0;
    for ( int k = 0; k < MCSPELLEN; k++ ) {
      kopie = *spel;
      kopie.dothemove (i);
      if ( speelRandomSpel (kopie) == spel->whois ( ) ) {
        huidigeScore++;
      }//if
    }//for
    if ( huidigeScore > besteScore ) {
      besteZet = i;
      besteScore = huidigeScore;
    }//if
  }//for
  return besteZet;
}//MCspeler::volgendeZet

