
//
// othellominimaxspeler.cc provides Minimaxspeler
// Roy van Hal en Walter Kosters
// 4 maart 2020
//

class Minimaxspeler : public Basisspeler {
public:
  Minimaxspeler (othello* spelPointer);
  int volgendeZet ( );
  int AlternatiefvolgendeZet ( );
  int gametree (othello* g, int depth, int & themove, int & evaluates);
  int evaluate (othello* g);
};//Minimaxspeler

//constructor
Minimaxspeler::Minimaxspeler (othello* spelPointer) {
  spel = spelPointer;
}//Minimaxspeler::Minimaxspeler

// evaluate game *g
// high value > 0: good for BLACK
// low value < 0: good for WHITE
// for instance: is g->board[0][0] equal to 'W' or 'B'?
int Minimaxspeler::evaluate (othello* g) {
  //TODO
  return 0;
}//Minimaxspeler::evaluate

// develop the game tree starting from game *g up to depth
// themove is the best move found (only needed at top level)
// evaluates counts number of calls to "evaluate"
// function returns best value found (not needed at top level)
int Minimaxspeler::gametree (othello* g, int depth, int & themove, int & evaluates) {
  if ( evaluates == 0 ) // sorry, no more resources ...
    return 0;

  //TODO
  // deal with terminal leaves (= end positions = completed games)
  // ...
  if ( depth == 0 ) {
    evaluates--; // only decreased here
    return evaluate (g);
  }//if

  //TODO
  // traverse the tree
  // ...
  return 0;
}//Minimaxspeler::gametree

// generate "best" minimax move; there is at least one
// version with RESOURCES
int Minimaxspeler::volgendeZet ( ) {
  int themove = rand ( ) % spel->numberofmoves ( ) + 1, mymove = themove;
  int oldevaluates = -1, evaluates = spel->RESOURCES;
  int depth = 0;
  while ( evaluates > 0 && oldevaluates != evaluates ) {
    depth++;
    mymove = themove; // best move from previous level
    oldevaluates = evaluates;
    gametree (spel,depth,themove,evaluates); // ignore return value
  }//while
  return mymove;
}//Minimaxspeler::volgendeZet 

// generate "best" minimax move; there is at least one
// version with depth
int Minimaxspeler::AlternatiefvolgendeZet ( ) {
  int themove = rand ( ) % spel->numberofmoves ( ) + 1;
  int evaluates = 1000000000;
  int depth = 5;
  gametree (spel,depth,themove,evaluates); // ignore return value
  //cout << 1000000000 - evaluates << " evaluaties ..." << endl;
  return themove;
}//Minimaxspeler::AlternatiefvolgendeZet

